Index: uspace/lib/ui/src/filedialog.c
===================================================================
--- uspace/lib/ui/src/filedialog.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/src/filedialog.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,340 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file File dialog
+ */
+
+#include <errno.h>
+#include <mem.h>
+#include <stdlib.h>
+#include <ui/entry.h>
+#include <ui/fixed.h>
+#include <ui/label.h>
+#include <ui/filedialog.h>
+#include <ui/pbutton.h>
+#include <ui/resource.h>
+#include <ui/ui.h>
+#include <ui/window.h>
+#include "../private/filedialog.h"
+
+static void ui_file_dialog_wnd_close(ui_window_t *, void *);
+
+ui_window_cb_t ui_file_dialog_wnd_cb = {
+	.close = ui_file_dialog_wnd_close
+};
+
+static void ui_file_dialog_bok_clicked(ui_pbutton_t *, void *);
+static void ui_file_dialog_bcancel_clicked(ui_pbutton_t *, void *);
+
+ui_pbutton_cb_t ui_file_dialog_bok_cb = {
+	.clicked = ui_file_dialog_bok_clicked
+};
+
+ui_pbutton_cb_t ui_file_dialog_bcancel_cb = {
+	.clicked = ui_file_dialog_bcancel_clicked
+};
+
+/** Initialize file dialog parameters structure.
+ *
+ * File dialog parameters structure must always be initialized using
+ * this function first.
+ *
+ * @param params File dialog parameters structure
+ */
+void ui_file_dialog_params_init(ui_file_dialog_params_t *params)
+{
+	memset(params, 0, sizeof(ui_file_dialog_params_t));
+}
+
+/** Create new file dialog.
+ *
+ * @param ui User interface
+ * @param params File dialog parameters
+ * @param rdialog Place to store pointer to new dialog
+ * @return EOK on success or an error code
+ */
+errno_t ui_file_dialog_create(ui_t *ui, ui_file_dialog_params_t *params,
+    ui_file_dialog_t **rdialog)
+{
+	errno_t rc;
+	ui_file_dialog_t *dialog;
+	ui_window_t *window = NULL;
+	ui_wnd_params_t wparams;
+	ui_fixed_t *fixed = NULL;
+	ui_label_t *label = NULL;
+	ui_entry_t *entry = NULL;
+	ui_pbutton_t *bok = NULL;
+	ui_pbutton_t *bcancel = NULL;
+	gfx_rect_t rect;
+	ui_resource_t *ui_res;
+
+	dialog = calloc(1, sizeof(ui_file_dialog_t));
+	if (dialog == NULL) {
+		rc = ENOMEM;
+		goto error;
+	}
+
+	ui_wnd_params_init(&wparams);
+	wparams.caption = params->caption;
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		wparams.rect.p0.x = 0;
+		wparams.rect.p0.y = 0;
+		wparams.rect.p1.x = 40;
+		wparams.rect.p1.y = 10;
+	} else {
+		wparams.rect.p0.x = 0;
+		wparams.rect.p0.y = 0;
+		wparams.rect.p1.x = 300;
+		wparams.rect.p1.y = 135;
+	}
+
+	rc = ui_window_create(ui, &wparams, &window);
+	if (rc != EOK)
+		goto error;
+
+	ui_window_set_cb(window, &ui_file_dialog_wnd_cb, dialog);
+
+	ui_res = ui_window_get_res(window);
+
+	rc = ui_fixed_create(&fixed);
+	if (rc != EOK)
+		goto error;
+
+	rc = ui_label_create(ui_res, "File Name:", &label);
+	if (rc != EOK)
+		goto error;
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 3;
+		rect.p0.y = 3;
+		rect.p1.x = 17;
+		rect.p1.y = 4;
+	} else {
+		rect.p0.x = 10;
+		rect.p0.y = 35;
+		rect.p1.x = 190;
+		rect.p1.y = 50;
+	}
+
+	ui_label_set_rect(label, &rect);
+
+	rc = ui_fixed_add(fixed, ui_label_ctl(label));
+	if (rc != EOK)
+		goto error;
+
+	label = NULL;
+
+	rc = ui_entry_create(window, "", &entry);
+	if (rc != EOK)
+		goto error;
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 3;
+		rect.p0.y = 5;
+		rect.p1.x = 37;
+		rect.p1.y = 6;
+	} else {
+		rect.p0.x = 10;
+		rect.p0.y = 55;
+		rect.p1.x = 290;
+		rect.p1.y = 80;
+	}
+
+	ui_entry_set_rect(entry, &rect);
+
+	rc = ui_fixed_add(fixed, ui_entry_ctl(entry));
+	if (rc != EOK)
+		goto error;
+
+	dialog->ename = entry;
+	entry = NULL;
+
+	rc = ui_pbutton_create(ui_res, "OK", &bok);
+	if (rc != EOK)
+		goto error;
+
+	ui_pbutton_set_cb(bok, &ui_file_dialog_bok_cb, dialog);
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 10;
+		rect.p0.y = 7;
+		rect.p1.x = 20;
+		rect.p1.y = 8;
+	} else {
+		rect.p0.x = 55;
+		rect.p0.y = 90;
+		rect.p1.x = 145;
+		rect.p1.y = 118;
+	}
+
+	ui_pbutton_set_rect(bok, &rect);
+
+	ui_pbutton_set_default(bok, true);
+
+	rc = ui_fixed_add(fixed, ui_pbutton_ctl(bok));
+	if (rc != EOK)
+		goto error;
+
+	dialog->bok = bok;
+	bok = NULL;
+
+	rc = ui_pbutton_create(ui_res, "Cancel", &bcancel);
+	if (rc != EOK)
+		goto error;
+
+	ui_pbutton_set_cb(bcancel, &ui_file_dialog_bcancel_cb, dialog);
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 22;
+		rect.p0.y = 7;
+		rect.p1.x = 32;
+		rect.p1.y = 8;
+	} else {
+		rect.p0.x = 155;
+		rect.p0.y = 90;
+		rect.p1.x = 245;
+		rect.p1.y = 118;
+	}
+
+	ui_pbutton_set_rect(bcancel, &rect);
+
+	rc = ui_fixed_add(fixed, ui_pbutton_ctl(bcancel));
+	if (rc != EOK)
+		goto error;
+
+	dialog->bcancel = bcancel;
+	bcancel = NULL;
+
+	ui_window_add(window, ui_fixed_ctl(fixed));
+	fixed = NULL;
+
+	rc = ui_window_paint(window);
+	if (rc != EOK)
+		goto error;
+
+	dialog->window = window;
+	*rdialog = dialog;
+	return EOK;
+error:
+	if (entry != NULL)
+		ui_entry_destroy(entry);
+	if (bok != NULL)
+		ui_pbutton_destroy(bok);
+	if (bcancel != NULL)
+		ui_pbutton_destroy(bcancel);
+	if (label != NULL)
+		ui_label_destroy(label);
+	if (fixed != NULL)
+		ui_fixed_destroy(fixed);
+	if (window != NULL)
+		ui_window_destroy(window);
+	if (dialog != NULL)
+		free(dialog);
+	return rc;
+}
+
+/** Destroy file dialog.
+ *
+ * @param dialog File dialog or @c NULL
+ */
+void ui_file_dialog_destroy(ui_file_dialog_t *dialog)
+{
+	if (dialog == NULL)
+		return;
+
+	ui_window_destroy(dialog->window);
+	free(dialog);
+}
+
+/** Set mesage dialog callback.
+ *
+ * @param dialog File dialog
+ * @param cb File dialog callbacks
+ * @param arg Callback argument
+ */
+void ui_file_dialog_set_cb(ui_file_dialog_t *dialog, ui_file_dialog_cb_t *cb,
+    void *arg)
+{
+	dialog->cb = cb;
+	dialog->arg = arg;
+}
+
+/** File dialog window close handler.
+ *
+ * @param window Window
+ * @param arg Argument (ui_file_dialog_t *)
+ */
+static void ui_file_dialog_wnd_close(ui_window_t *window, void *arg)
+{
+	ui_file_dialog_t *dialog = (ui_file_dialog_t *) arg;
+
+	if (dialog->cb != NULL && dialog->cb->close != NULL)
+		dialog->cb->close(dialog, dialog->arg);
+}
+
+/** File dialog OK button click handler.
+ *
+ * @param pbutton Push button
+ * @param arg Argument (ui_file_dialog_t *)
+ */
+static void ui_file_dialog_bok_clicked(ui_pbutton_t *pbutton, void *arg)
+{
+	ui_file_dialog_t *dialog = (ui_file_dialog_t *) arg;
+	const char *fname;
+
+	if (dialog->cb != NULL && dialog->cb->bok != NULL) {
+		fname = ui_entry_get_text(dialog->ename);
+		dialog->cb->bok(dialog, dialog->arg, fname);
+	}
+}
+
+/** File dialog cancel button click handler.
+ *
+ * @param pbutton Push button
+ * @param arg Argument (ui_file_dialog_t *)
+ */
+static void ui_file_dialog_bcancel_clicked(ui_pbutton_t *pbutton, void *arg)
+{
+	ui_file_dialog_t *dialog = (ui_file_dialog_t *) arg;
+
+	if (dialog->cb != NULL && dialog->cb->bcancel != NULL)
+		dialog->cb->bcancel(dialog, dialog->arg);
+}
+
+/** @}
+ */
Index: uspace/lib/ui/src/fixed.c
===================================================================
--- uspace/lib/ui/src/fixed.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/src/fixed.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -46,5 +46,7 @@
 static void ui_fixed_ctl_destroy(void *);
 static errno_t ui_fixed_ctl_paint(void *);
+static ui_evclaim_t ui_fixed_ctl_kbd_event(void *, kbd_event_t *);
 static ui_evclaim_t ui_fixed_ctl_pos_event(void *, pos_event_t *);
+static void ui_fixed_ctl_unfocus(void *);
 
 /** Push button control ops */
@@ -52,5 +54,7 @@
 	.destroy = ui_fixed_ctl_destroy,
 	.paint = ui_fixed_ctl_paint,
-	.pos_event = ui_fixed_ctl_pos_event
+	.kbd_event = ui_fixed_ctl_kbd_event,
+	.pos_event = ui_fixed_ctl_pos_event,
+	.unfocus = ui_fixed_ctl_unfocus
 };
 
@@ -209,4 +213,27 @@
 }
 
+/** Handle fixed layout keyboard event.
+ *
+ * @param fixed Fixed layout
+ * @param kbd_event Keyboard event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t ui_fixed_kbd_event(ui_fixed_t *fixed, kbd_event_t *event)
+{
+	ui_fixed_elem_t *elem;
+	ui_evclaim_t claimed;
+
+	elem = ui_fixed_first(fixed);
+	while (elem != NULL) {
+		claimed = ui_control_kbd_event(elem->control, event);
+		if (claimed == ui_claimed)
+			return ui_claimed;
+
+		elem = ui_fixed_next(elem);
+	}
+
+	return ui_unclaimed;
+}
+
 /** Handle fixed layout position event.
  *
@@ -232,4 +259,20 @@
 }
 
+/** Handle fixed layout window unfocus notification.
+ *
+ * @param fixed Fixed layout
+ */
+void ui_fixed_unfocus(ui_fixed_t *fixed)
+{
+	ui_fixed_elem_t *elem;
+
+	elem = ui_fixed_first(fixed);
+	while (elem != NULL) {
+		ui_control_unfocus(elem->control);
+
+		elem = ui_fixed_next(elem);
+	}
+}
+
 /** Destroy fixed layout control.
  *
@@ -253,4 +296,17 @@
 
 	return ui_fixed_paint(fixed);
+}
+
+/** Handle fixed layout control keyboard event.
+ *
+ * @param arg Argument (ui_fixed_t *)
+ * @param kbd_event Keyboard event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t ui_fixed_ctl_kbd_event(void *arg, kbd_event_t *event)
+{
+	ui_fixed_t *fixed = (ui_fixed_t *) arg;
+
+	return ui_fixed_kbd_event(fixed, event);
 }
 
@@ -268,4 +324,15 @@
 }
 
+/** Handle fixed layout control window unfocus notification.
+ *
+ * @param arg Argument (ui_fixed_t *)
+ */
+void ui_fixed_ctl_unfocus(void *arg)
+{
+	ui_fixed_t *fixed = (ui_fixed_t *) arg;
+
+	ui_fixed_unfocus(fixed);
+}
+
 /** @}
  */
Index: uspace/lib/ui/src/image.c
===================================================================
--- uspace/lib/ui/src/image.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/src/image.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -37,4 +37,5 @@
 #include <gfx/bitmap.h>
 #include <gfx/context.h>
+#include <gfx/render.h>
 #include <gfx/text.h>
 #include <stdlib.h>
@@ -177,6 +178,9 @@
 	 */
 	gfx_rect_rtranslate(&offs, &irect, &srect);
-	return gfx_bitmap_render(image->bitmap, &srect, &offs);
-
+	rc = gfx_bitmap_render(image->bitmap, &srect, &offs);
+	if (rc != EOK)
+		return rc;
+
+	return gfx_update(image->res->gc);
 }
 
Index: uspace/lib/ui/src/label.c
===================================================================
--- uspace/lib/ui/src/label.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/lib/ui/src/label.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -193,12 +193,13 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.color = label->res->wnd_text_color;
 	fmt.halign = label->halign;
 	fmt.valign = gfx_valign_top;
 
-	rc = gfx_set_color(label->res->gc, label->res->wnd_text_color);
-	if (rc != EOK)
-		goto error;
-
 	rc = gfx_puttext(label->res->font, &pos, &fmt, label->text);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_update(label->res->gc);
 	if (rc != EOK)
 		goto error;
Index: uspace/lib/ui/src/menu.c
===================================================================
--- uspace/lib/ui/src/menu.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/src/menu.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,407 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Menu
+ */
+
+#include <adt/list.h>
+#include <errno.h>
+#include <gfx/color.h>
+#include <gfx/context.h>
+#include <gfx/render.h>
+#include <gfx/text.h>
+#include <io/pos_event.h>
+#include <stdlib.h>
+#include <str.h>
+#include <ui/control.h>
+#include <ui/paint.h>
+#include <ui/popup.h>
+#include <ui/menu.h>
+#include <ui/menuentry.h>
+#include <ui/resource.h>
+#include <ui/window.h>
+#include "../private/menubar.h"
+#include "../private/menu.h"
+#include "../private/resource.h"
+
+enum {
+	menu_frame_w = 4,
+	menu_frame_h = 4,
+	menu_frame_w_text = 2,
+	menu_frame_h_text = 1
+};
+
+static void ui_menu_popup_close(ui_popup_t *, void *);
+static void ui_menu_popup_pos(ui_popup_t *, void *, pos_event_t *);
+
+static ui_popup_cb_t ui_menu_popup_cb = {
+	.close = ui_menu_popup_close,
+	.pos = ui_menu_popup_pos
+};
+
+/** Create new menu.
+ *
+ * @param mbar Menu bar
+ * @param caption Caption
+ * @param rmenu Place to store pointer to new menu
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t ui_menu_create(ui_menu_bar_t *mbar, const char *caption,
+    ui_menu_t **rmenu)
+{
+	ui_menu_t *menu;
+
+	menu = calloc(1, sizeof(ui_menu_t));
+	if (menu == NULL)
+		return ENOMEM;
+
+	menu->caption = str_dup(caption);
+	if (menu->caption == NULL) {
+		free(menu);
+		return ENOMEM;
+	}
+
+	menu->mbar = mbar;
+	list_append(&menu->lmenus, &mbar->menus);
+	list_initialize(&menu->entries);
+
+	*rmenu = menu;
+	return EOK;
+}
+
+/** Destroy menu.
+ *
+ * @param menu Menu or @c NULL
+ */
+void ui_menu_destroy(ui_menu_t *menu)
+{
+	ui_menu_entry_t *mentry;
+
+	if (menu == NULL)
+		return;
+
+	/* Destroy entries */
+	mentry = ui_menu_entry_first(menu);
+	while (mentry != NULL) {
+		ui_menu_entry_destroy(mentry);
+		mentry = ui_menu_entry_first(menu);
+	}
+
+	list_remove(&menu->lmenus);
+	free(menu->caption);
+	free(menu);
+}
+
+/** Get first menu in menu bar.
+ *
+ * @param mbar Menu bar
+ * @return First menu or @c NULL if there is none
+ */
+ui_menu_t *ui_menu_first(ui_menu_bar_t *mbar)
+{
+	link_t *link;
+
+	link = list_first(&mbar->menus);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ui_menu_t, lmenus);
+}
+
+/** Get next menu in menu bar.
+ *
+ * @param cur Current menu
+ * @return Next menu or @c NULL if @a cur is the last one
+ */
+ui_menu_t *ui_menu_next(ui_menu_t *cur)
+{
+	link_t *link;
+
+	link = list_next(&cur->lmenus, &cur->mbar->menus);
+	if (link == NULL)
+		return NULL;
+
+	return list_get_instance(link, ui_menu_t, lmenus);
+}
+
+/** Get menu caption.
+ *
+ * @param menu Menu
+ * @return Caption (owned by @a menu)
+ */
+const char *ui_menu_caption(ui_menu_t *menu)
+{
+	return menu->caption;
+}
+
+/** Get menu geometry.
+ *
+ * @param menu Menu
+ * @param spos Starting position
+ * @param geom Structure to fill in with computed geometry
+ */
+void ui_menu_get_geom(ui_menu_t *menu, gfx_coord2_t *spos,
+    ui_menu_geom_t *geom)
+{
+	ui_resource_t *res;
+	gfx_coord2_t edim;
+	gfx_coord_t frame_w;
+	gfx_coord_t frame_h;
+
+	res = ui_window_get_res(menu->mbar->window);
+
+	if (res->textmode) {
+		frame_w = menu_frame_w_text;
+		frame_h = menu_frame_h_text;
+	} else {
+		frame_w = menu_frame_w;
+		frame_h = menu_frame_h;
+	}
+
+	edim.x = ui_menu_entry_calc_width(menu, menu->max_caption_w,
+	    menu->max_shortcut_w);
+	edim.y = menu->total_h;
+
+	geom->outer_rect.p0 = *spos;
+	geom->outer_rect.p1.x = spos->x + edim.x + 2 * frame_w;
+	geom->outer_rect.p1.y = spos->y + edim.y + 2 * frame_h;
+
+	geom->entries_rect.p0.x = spos->x + frame_w;
+	geom->entries_rect.p0.y = spos->y + frame_h;
+	geom->entries_rect.p1.x = geom->entries_rect.p0.x + edim.x;
+	geom->entries_rect.p1.y = geom->entries_rect.p0.x + edim.y;
+}
+
+/** Get menu rectangle.
+ *
+ * @param menu Menu
+ * @param spos Starting position (top-left corner)
+ * @param rect Place to store menu rectangle
+ */
+void ui_menu_get_rect(ui_menu_t *menu, gfx_coord2_t *spos, gfx_rect_t *rect)
+{
+	ui_menu_geom_t geom;
+
+	ui_menu_get_geom(menu, spos, &geom);
+	*rect = geom.outer_rect;
+}
+
+/** Get UI resource from menu.
+ *
+ * @param menu Menu
+ * @return UI resource
+ */
+ui_resource_t *ui_menu_get_res(ui_menu_t *menu)
+{
+	return ui_popup_get_res(menu->popup);
+}
+
+/** Open menu.
+ *
+ * @param menu Menu
+ * @param prect Parent rectangle around which the menu should be placed
+ */
+errno_t ui_menu_open(ui_menu_t *menu, gfx_rect_t *prect)
+{
+	ui_popup_t *popup = NULL;
+	ui_popup_params_t params;
+	ui_menu_geom_t geom;
+	gfx_coord2_t mpos;
+	errno_t rc;
+
+	/* Determine menu dimensions */
+
+	mpos.x = 0;
+	mpos.y = 0;
+	ui_menu_get_geom(menu, &mpos, &geom);
+
+	ui_popup_params_init(&params);
+	params.rect = geom.outer_rect;
+	params.place = *prect;
+
+	rc = ui_popup_create(menu->mbar->ui, menu->mbar->window, &params,
+	    &popup);
+	if (rc != EOK)
+		return rc;
+
+	menu->popup = popup;
+	ui_popup_set_cb(popup, &ui_menu_popup_cb, menu);
+
+	return ui_menu_paint(menu, &mpos);
+}
+
+/** Close menu.
+ *
+ * @param menu Menu
+ */
+void ui_menu_close(ui_menu_t *menu)
+{
+	ui_popup_destroy(menu->popup);
+	menu->popup = NULL;
+}
+
+/** Paint menu.
+ *
+ * @param menu Menu
+ * @param spos Starting position (top-left corner)
+ * @return EOK on success or an error code
+ */
+errno_t ui_menu_paint(ui_menu_t *menu, gfx_coord2_t *spos)
+{
+	ui_resource_t *res;
+	gfx_coord2_t pos;
+	ui_menu_entry_t *mentry;
+	ui_menu_geom_t geom;
+	gfx_rect_t bg_rect;
+	errno_t rc;
+
+	res = ui_menu_get_res(menu);
+	ui_menu_get_geom(menu, spos, &geom);
+
+	/* Paint menu frame */
+
+	rc = gfx_set_color(res->gc, res->wnd_face_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = ui_paint_outset_frame(res, &geom.outer_rect, &bg_rect);
+	if (rc != EOK)
+		goto error;
+
+	/* Paint menu background */
+
+	rc = gfx_set_color(res->gc, res->wnd_face_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_fill_rect(res->gc, &bg_rect);
+	if (rc != EOK)
+		goto error;
+
+	/* Paint entries */
+	pos = geom.entries_rect.p0;
+
+	mentry = ui_menu_entry_first(menu);
+	while (mentry != NULL) {
+		rc = ui_menu_entry_paint(mentry, &pos);
+		if (rc != EOK)
+			goto error;
+
+		pos.y += ui_menu_entry_height(mentry);
+		mentry = ui_menu_entry_next(mentry);
+	}
+
+	rc = gfx_update(res->gc);
+	if (rc != EOK)
+		goto error;
+
+	return EOK;
+error:
+	return rc;
+}
+
+/** Handle position event in menu.
+ *
+ * @param menu Menu
+ * @param spos Starting position (top-left corner)
+ * @param event Position event
+ * @return ui_claimed iff the event was claimed
+ */
+ui_evclaim_t ui_menu_pos_event(ui_menu_t *menu, gfx_coord2_t *spos,
+    pos_event_t *event)
+{
+	ui_menu_geom_t geom;
+	ui_menu_entry_t *mentry;
+	gfx_coord2_t pos;
+	gfx_coord2_t epos;
+	ui_evclaim_t claimed;
+
+	ui_menu_get_geom(menu, spos, &geom);
+	epos.x = event->hpos;
+	epos.y = event->vpos;
+
+	pos = geom.entries_rect.p0;
+
+	mentry = ui_menu_entry_first(menu);
+	while (mentry != NULL) {
+		claimed = ui_menu_entry_pos_event(mentry, &pos, event);
+		if (claimed == ui_claimed)
+			return ui_claimed;
+
+		pos.y += ui_menu_entry_height(mentry);
+		mentry = ui_menu_entry_next(mentry);
+	}
+
+	/* Event inside menu? */
+	if (gfx_pix_inside_rect(&epos, &geom.outer_rect)) {
+		/* Claim event */
+		return ui_claimed;
+	} else {
+		/* Press outside menu - close it */
+		if (event->type == POS_PRESS)
+			ui_menu_bar_select(menu->mbar, NULL, NULL);
+	}
+
+	return ui_unclaimed;
+}
+
+/** Handle close event in menu popup window.
+ *
+ * @param popup Menu popup window
+ * @param arg Argument (ui_menu_t *)
+ */
+static void ui_menu_popup_close(ui_popup_t *popup, void *arg)
+{
+	ui_menu_t *menu = (ui_menu_t *)arg;
+
+	/* Close the menu */
+	ui_menu_bar_select(menu->mbar, NULL, NULL);
+}
+
+/** Handle position event in menu popup window.
+ *
+ * @param popup Menu popup window
+ * @param arg Argument (ui_menu_t *)
+ * @param event Position event
+ */
+static void ui_menu_popup_pos(ui_popup_t *popup, void *arg, pos_event_t *event)
+{
+	ui_menu_t *menu = (ui_menu_t *)arg;
+	gfx_coord2_t spos;
+
+	spos.x = 0;
+	spos.y = 0;
+	ui_menu_pos_event(menu, &spos, event);
+}
+
+/** @}
+ */
Index: uspace/lib/ui/src/menubar.c
===================================================================
--- uspace/lib/ui/src/menubar.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
+++ uspace/lib/ui/src/menubar.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -0,0 +1,354 @@
+/*
+ * Copyright (c) 2021 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Menu bar
+ */
+
+#include <adt/list.h>
+#include <errno.h>
+#include <gfx/color.h>
+#include <gfx/context.h>
+#include <gfx/render.h>
+#include <gfx/text.h>
+#include <io/pos_event.h>
+#include <stdlib.h>
+#include <str.h>
+#include <ui/control.h>
+#include <ui/paint.h>
+#include <ui/menu.h>
+#include <ui/menubar.h>
+#include <ui/window.h>
+#include "../private/menubar.h"
+#include "../private/resource.h"
+
+enum {
+	menubar_hpad = 4,
+	menubar_vpad = 4,
+	menubar_hpad_text = 1,
+	menubar_vpad_text = 0
+};
+
+static void ui_menu_bar_ctl_destroy(void *);
+static errno_t ui_menu_bar_ctl_paint(void *);
+static ui_evclaim_t ui_menu_bar_ctl_pos_event(void *, pos_event_t *);
+
+/** Menu bar control ops */
+ui_control_ops_t ui_menu_bar_ops = {
+	.destroy = ui_menu_bar_ctl_destroy,
+	.paint = ui_menu_bar_ctl_paint,
+	.pos_event = ui_menu_bar_ctl_pos_event,
+};
+
+/** Create new menu bar.
+ *
+ * @param ui UI
+ * @param window Window that will contain the menu bar
+ * @param rmbar Place to store pointer to new menu bar
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t ui_menu_bar_create(ui_t *ui, ui_window_t *window, ui_menu_bar_t **rmbar)
+{
+	ui_menu_bar_t *mbar;
+	errno_t rc;
+
+	mbar = calloc(1, sizeof(ui_menu_bar_t));
+	if (mbar == NULL)
+		return ENOMEM;
+
+	rc = ui_control_new(&ui_menu_bar_ops, (void *) mbar, &mbar->control);
+	if (rc != EOK) {
+		free(mbar);
+		return rc;
+	}
+
+	mbar->ui = ui;
+	mbar->window = window;
+	list_initialize(&mbar->menus);
+	*rmbar = mbar;
+	return EOK;
+}
+
+/** Destroy menu bar
+ *
+ * @param mbar Menu bar or @c NULL
+ */
+void ui_menu_bar_destroy(ui_menu_bar_t *mbar)
+{
+	ui_menu_t *menu;
+
+	if (mbar == NULL)
+		return;
+
+	/* Destroy menus */
+	menu = ui_menu_first(mbar);
+	while (menu != NULL) {
+		ui_menu_destroy(menu);
+		menu = ui_menu_first(mbar);
+	}
+
+	ui_control_delete(mbar->control);
+	free(mbar);
+}
+
+/** Get base control from menu bar.
+ *
+ * @param mbar Menu bar
+ * @return Control
+ */
+ui_control_t *ui_menu_bar_ctl(ui_menu_bar_t *mbar)
+{
+	return mbar->control;
+}
+
+/** Set menu bar rectangle.
+ *
+ * @param mbar Menu bar
+ * @param rect New menu bar rectangle
+ */
+void ui_menu_bar_set_rect(ui_menu_bar_t *mbar, gfx_rect_t *rect)
+{
+	mbar->rect = *rect;
+}
+
+/** Paint menu bar.
+ *
+ * @param mbar Menu bar
+ * @return EOK on success or an error code
+ */
+errno_t ui_menu_bar_paint(ui_menu_bar_t *mbar)
+{
+	ui_resource_t *res;
+	gfx_text_fmt_t fmt;
+	gfx_coord2_t pos;
+	gfx_coord2_t tpos;
+	gfx_rect_t rect;
+	gfx_color_t *bg_color;
+	ui_menu_t *menu;
+	const char *caption;
+	gfx_coord_t width;
+	gfx_coord_t hpad;
+	gfx_coord_t vpad;
+	errno_t rc;
+
+	res = ui_window_get_res(mbar->window);
+
+	/* Paint menu bar background */
+
+	rc = gfx_set_color(res->gc, res->wnd_face_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_fill_rect(res->gc, &mbar->rect);
+	if (rc != EOK)
+		goto error;
+
+	if (res->textmode) {
+		hpad = menubar_hpad_text;
+		vpad = menubar_vpad_text;
+	} else {
+		hpad = menubar_hpad;
+		vpad = menubar_vpad;
+	}
+
+	pos = mbar->rect.p0;
+
+	gfx_text_fmt_init(&fmt);
+	fmt.halign = gfx_halign_left;
+	fmt.valign = gfx_valign_top;
+
+	menu = ui_menu_first(mbar);
+	while (menu != NULL) {
+		caption = ui_menu_caption(menu);
+		width = gfx_text_width(res->font, caption) + 2 * hpad;
+		tpos.x = pos.x + hpad;
+		tpos.y = pos.y + vpad;
+
+		rect.p0 = pos;
+		rect.p1.x = rect.p0.x + width;
+		rect.p1.y = mbar->rect.p1.y;
+
+		if (menu == mbar->selected) {
+			fmt.color = res->wnd_sel_text_color;
+			bg_color = res->wnd_sel_text_bg_color;
+		} else {
+			fmt.color = res->wnd_text_color;
+			bg_color = res->wnd_face_color;
+		}
+
+		rc = gfx_set_color(res->gc, bg_color);
+		if (rc != EOK)
+			goto error;
+
+		rc = gfx_fill_rect(res->gc, &rect);
+		if (rc != EOK)
+			goto error;
+
+		rc = gfx_puttext(res->font, &tpos, &fmt, caption);
+		if (rc != EOK)
+			goto error;
+
+		pos.x += width;
+		menu = ui_menu_next(menu);
+	}
+
+	rc = gfx_update(res->gc);
+	if (rc != EOK)
+		goto error;
+
+	return EOK;
+error:
+	return rc;
+}
+
+/** Select or deselect menu from menu bar.
+ *
+ * Select @a menu. If @a menu is @c NULL or it is already selected,
+ * then select none.
+ *
+ * @param mbar Menu bar
+ * @param rect Menu bar entry rectangle
+ * @param menu Menu to select (or deselect if selected) or @c NULL
+ */
+void ui_menu_bar_select(ui_menu_bar_t *mbar, gfx_rect_t *rect,
+    ui_menu_t *menu)
+{
+	ui_menu_t *old_menu;
+
+	old_menu = mbar->selected;
+
+	if (mbar->selected != menu)
+		mbar->selected = menu;
+	else
+		mbar->selected = NULL;
+
+	/* Close previously open menu */
+	if (old_menu != NULL)
+		(void) ui_menu_close(old_menu);
+
+	(void) ui_menu_bar_paint(mbar);
+
+	if (mbar->selected != NULL) {
+		(void) ui_menu_open(mbar->selected, rect);
+	}
+}
+
+/** Handle menu bar position event.
+ *
+ * @param mbar Menu bar
+ * @param pos_event Position event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t ui_menu_bar_pos_event(ui_menu_bar_t *mbar, pos_event_t *event)
+{
+	ui_resource_t *res;
+	gfx_coord2_t pos;
+	gfx_rect_t rect;
+	ui_menu_t *menu;
+	const char *caption;
+	gfx_coord_t width;
+	gfx_coord_t hpad;
+	gfx_coord2_t ppos;
+
+	res = ui_window_get_res(mbar->window);
+
+	ppos.x = event->hpos;
+	ppos.y = event->vpos;
+
+	if (res->textmode) {
+		hpad = menubar_hpad_text;
+	} else {
+		hpad = menubar_hpad;
+	}
+
+	pos = mbar->rect.p0;
+
+	menu = ui_menu_first(mbar);
+	while (menu != NULL) {
+		caption = ui_menu_caption(menu);
+		width = gfx_text_width(res->font, caption) + 2 * hpad;
+
+		rect.p0 = pos;
+		rect.p1.x = rect.p0.x + width;
+		rect.p1.y = mbar->rect.p1.y;
+
+		/* Check if press is inside menu bar entry */
+		if (event->type == POS_PRESS &&
+		    gfx_pix_inside_rect(&ppos, &rect)) {
+			ui_menu_bar_select(mbar, &rect, menu);
+			return ui_claimed;
+		}
+
+		pos.x += width;
+		menu = ui_menu_next(menu);
+	}
+
+	return ui_unclaimed;
+}
+
+/** Destroy menu bar control.
+ *
+ * @param arg Argument (ui_menu_bar_t *)
+ */
+void ui_menu_bar_ctl_destroy(void *arg)
+{
+	ui_menu_bar_t *mbar = (ui_menu_bar_t *) arg;
+
+	ui_menu_bar_destroy(mbar);
+}
+
+/** Paint menu bar control.
+ *
+ * @param arg Argument (ui_menu_bar_t *)
+ * @return EOK on success or an error code
+ */
+errno_t ui_menu_bar_ctl_paint(void *arg)
+{
+	ui_menu_bar_t *mbar = (ui_menu_bar_t *) arg;
+
+	return ui_menu_bar_paint(mbar);
+}
+
+/** Handle menu bar control position event.
+ *
+ * @param arg Argument (ui_menu_bar_t *)
+ * @param pos_event Position event
+ * @return @c ui_claimed iff the event is claimed
+ */
+ui_evclaim_t ui_menu_bar_ctl_pos_event(void *arg, pos_event_t *event)
+{
+	ui_menu_bar_t *mbar = (ui_menu_bar_t *) arg;
+
+	return ui_menu_bar_pos_event(mbar, event);
+}
+
+/** @}
+ */
